//
//      MainWindow.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//
#include "MainWindow.hpp"
#include "syncscheduler_res.h"
#include "SyncScheduler.hpp"
#include "SoftkeyWindow.hpp"
#include "PreferenceDialog.hpp"
#include "VersionDialog.hpp"
#include "OneDayWindow.hpp"
#define     LABEL_SOFTKEY1          ("Finish")
#define     LABEL_SOFTKEY2          ("Menu")        //("\xD2\xC6\xAD\xB0")
#define     LABEL_SOFTKEY3          ("Select")
#define     MULTIDIALOG_HEIGHT      (136)
#define     CAL_TOP_MARGIN          (25)
#define     CAL_SIDE_MARGIN         (20)
#define     MAXLINE_TO_SHOW         (2)
enum 
{
    OPERATION_PREFERENCE,
    OPERATION_VERSION,
    OPERATION_LIMIT
};


MainWindow::MainWindow(SFRApplicationPtr director) static_throws : SFRPlainWindow(director, SFXRectangle(0, 0, 0, 0), BEHAVIOR_SFRPLAINWINDOW, ATTRIBUTE_MAINWINDOW)
{
    SoftkeyWindowPtr softkey;
    SoftkeyWindow::Initialize(this);
    if (static_try()) {
        // Register drawing handler
        static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent)));
        if (static_try()) {
            // Register key handler 
            static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
        }
    }
    if (static_try()) {
        static_throw(RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
        if (static_try()) {
            SetBaseBound(SyncScheduler::CalculateWindowPosition());
            if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_1, LABEL_SOFTKEY1));
                if (static_try()) {
                    static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2));
                    if (static_try()) {
                        static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
                        if (static_try()) {
                            SetReference(softkey->Bind(this));
                            // Calendar square unit length
                            _boxSizeX = (GetContentWorld().GetRight() - 2 * CAL_SIDE_MARGIN) / 7;
							_boxSizeY = _boxSizeX - 3; 
                            // Left end of calendar
                            _calLeft = (GetContentWorld().GetRight() - 7 * _boxSizeX) / 2;
                            // Get current date
                            _cursor = SFXDate::CurrentDate();
							_showcursor=1;
                        }
                    }
                }
            }
        }
    }
    return;
}


MainWindow::~MainWindow(Void)
{
    SoftkeyWindow::Terminate(this);
    return;
}


// Drawing handler
HANDLER_IMPLEMENT_VOIDRENDER(MainWindow, OnRenderContent, graphics)
{
    SFXConfigPtr option = SyncScheduler::GetOption();
    // Get the screen size
    SFXRectangle screenRect(GetContentWorld());
    // Get cursor position
    SInt16 year = _cursor.GetYear();
    SInt16 month = _cursor.GetMonth();
    SInt16 day = _cursor.GetDay();
    // Get current date
    SFXDate current = SFXDate::CurrentDate();
    SFXAnsiString monthlong;
    SFXAnsiString daylong;
    SFXAnsiString dateString;

    switch (month) {
    case 1:
        monthlong = "January";
        break;
    case 2:
        monthlong = "February";
        break;
    case 3:
        monthlong = "March";
        break;
    case 4:
        monthlong = "April";
        break;
    case 5:
        monthlong = "May";
        break;
    case 6:
        monthlong = "June";
        break;
    case 7:
        monthlong = "July";
        break;
    case 8:
        monthlong = "August";
        break;
    case 9:
        monthlong = "September";
        break;
    case 10:
        monthlong = "October";
        break;
    case 11:
        monthlong = "November";
        break;
    case 12:
        monthlong = "Decenber";
        break;
    default:
        monthlong = "Error";
        break;
    }
    daylong= SFXAnsiString::Format("%d",day);
    switch (day%10) {
    case 1:
		if (day == 11) {
			daylong = daylong + "th";
		}
		else {
			daylong = daylong + "st";
		}
        break;
    case 2:
		if (day == 12) {
			daylong = daylong + "th";
		}
		else {
			daylong = daylong + "nd";
		}
        break;
    case 3:
		if (day == 13) {
			daylong = daylong + "th";
		}
		else {
			daylong = daylong + "rd";
		}
        break;
    default:
        daylong = daylong+"th";
        break;
    }
    Bool longDateDisplay=option->ReadBool(OPTION_LONGDATE, false);
    Bool mdyStyle=option->ReadBool(OPTION_MDY, false);
    if ( mdyStyle ) {
        if (longDateDisplay) {
            dateString = SFXAnsiString::Format("%s %s, %2d", monthlong.GetCString(),daylong.GetCString(),year);
        }
        else {
            dateString = SFXAnsiString::Format("%2d-%2d, %2d", month,day,year);
        }
    }
    else {
        if ( longDateDisplay ) {
            dateString = SFXAnsiString::Format("%2d, %s %s", year,monthlong.GetCString() ,daylong.GetCString());
        }
        else {
            dateString= SFXAnsiString::Format("%2d, %2d-%2d",year, month,day);
        }
    }
    // ScreenRect is painted out with white
    graphics->FillRectangle(screenRect, SFXRGBColor(0xff, 0xff, 0xff, 0x00));
    // Drawing the frame of the calendar 
    DrawCalendarLine(screenRect, graphics); 
    // Drawing the date at the top
    graphics->DrawText( dateString, SFXGrid(CAL_SIDE_MARGIN, 0));
    // Drawing the days of the week part of calendar. 
    DrawDayOfWeek(screenRect, graphics); 
    // Drawing the date part of the calendar. 
    DrawDate(current, screenRect, graphics);
    // If a schedule exists, it is drawn on the bottom. 
    if (SyncScheduler::GetVCalCollection()->IsDataExist(year, month, day)) {
        DrawContent(screenRect, graphics);
    }
    return;
}


// Drawing the frame of the calendar. 
Void MainWindow::DrawCalendarLine(SFXRectangleConstRef /*screenRect*/, SFXGraphicsPtr graphics)
{
    // Vertical line
    SFXLine varLine; 
    // Horizontal line
    SFXLine holLine; 
    SInt16 i;
    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0));
    varLine.Set(_calLeft, CAL_TOP_MARGIN, _calLeft, CAL_TOP_MARGIN + 7 * _boxSizeY);
    holLine.Set(_calLeft, CAL_TOP_MARGIN, _calLeft + 7 * _boxSizeX, CAL_TOP_MARGIN);
    // Drawing vertical
    for (i = 1; i <= 8 ; ++i) {
        graphics->DrawLine(varLine);
        // Only _ boxSize moves the Vertical line to the right. 
        varLine.Offset(_boxSizeX, 0); 
    }
    // Drawing Horizontal
    for (i = 1; i <= 8 ; ++i) {
        graphics->DrawLine(holLine);
        // Only _ boxSize moves the horizontal line to the bottom. 
        holLine.Offset(0, _boxSizeY);
    }
}


// Drawing the days of the week part of the calendar. 
Void MainWindow::DrawDayOfWeek(SFXRectangleConstRef /*screenRect*/, SFXGraphicsPtr graphics)
{
    SFXRectangle calRect;
    static ACharConst youbi[][3] = 
    {
        "SU", "MO", "TU", "WE", "TH", "FR", "SA"
    };
    SInt16 i;

    calRect.Set(_calLeft + 1, CAL_TOP_MARGIN + 1, _boxSizeX - 1, _boxSizeY - 1);
    // Drawing the days of the week
    for (i = 1 ; i <= 7 ; ++i) {
        // Set the colors for Saturday,Sunday and Weekdays
        if ( i==1 || i==7) {
            _DayBackGroundColor=SFXRGBColor(69, 105, 250,0);
        }
        else {
            _DayBackGroundColor=SFXRGBColor(150, 255, 125, 0);
        }
        graphics->FillRectangle(calRect, _DayBackGroundColor );
        graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0));
        graphics->DrawText(youbi[i - 1], calRect);
        calRect.AddX(_boxSizeX);
    }
}


// Drawing the date part of the calendar. 
Void MainWindow::DrawDate(SFXDateConstRef current, SFXRectangleConstRef /*screenRect*/, SFXGraphicsPtr graphics)
{
    SFXRectangle calRect;
    SFXDate tempDate;
    SInt16 i;

    // Get a day of the week from the month
    tempDate.Set(_cursor);
    tempDate.SetDay(1);
    SInt16 dayOfWeek = (tempDate.GetDayOfWeek() + 1) % 7;
    // The rectangle is moved to the position of a day on the second line.
    calRect.Set(_calLeft + 1, CAL_TOP_MARGIN + _boxSizeY +1, _boxSizeX - 1, _boxSizeY - 1);
    calRect.AddX(_boxSizeX * dayOfWeek);
    // Get the date of the cursor position
    SInt16 year = _cursor.GetYear();
    SInt16 month = _cursor.GetMonth();
    SInt16 day = _cursor.GetDay();
    // Get the last day of the current month
    tempDate.Set(year, month + 1, 1);
    tempDate.SubDay(1);
    SInt32 endDay = tempDate.GetDay();
    // Drawing from first day to the last day of the month
    for (i = 1; i <= endDay; ++i) {
        // Set the colors for Saturday,Sunday and Weekdays
        if (dayOfWeek==0 || dayOfWeek==6) {
            _DayBackGroundColor=SFXRGBColor(193, 205, 253, 0);
            graphics->FillRectangle(calRect, _DayBackGroundColor);
        } 
        else
        _DayBackGroundColor=SFXRGBColor(210, 255, 172, 0);
        graphics->FillRectangle(calRect, _DayBackGroundColor);
        if (current.GetYear() == year
        && current.GetMonth() == month
        && current.GetDay() == i) {
            // Drawing the color that indicates the current day.
            _DayBackGroundColor=SFXRGBColor(255, 204, 0, 0);
            graphics->FillRectangle(calRect, _DayBackGroundColor);
        }
        // If the day corresponds to the date where the cursor points.
        if (day == i) {
            // Drawing cursor
            graphics->FillBevel(calRect, SFXBevelColor(SFXRGBColor (255, 30, 30, 0),_DayBackGroundColor,SFXRGBColor (255, 0, 0, 0)   ),true,true,true,true);
        }
        // If the current day contains a schedule, mark it
        if (SyncScheduler::GetVCalCollection()->IsDataExist(year, month, i)) {
            SFXRectangle pRect(calRect.GetLeft() + 2, calRect.GetTop() + 2, 3, 3);
            graphics->FillRectangle(pRect, SFXRGBColor(255, 0, 0, 0));
        }
        // Drawing the number
        graphics->DrawText(SFXAnsiString::Format("%2d",i), calRect, SFXRGBColor(0, 0, 0, 0)); 
        if (dayOfWeek == 6) {
            // When the end of the week is reached
            dayOfWeek = 0;
            calRect.SubX(_boxSizeX * 6);     // The rectangle is moved left. 
            calRect.AddY(_boxSizeY);         // The rectangle is moved down
        } 
        else {
            ++dayOfWeek;
            calRect.AddX(_boxSizeX);         // The rectangle is moved to right
        }
    }
    return;
}


// Drawing the schedule part of the calendar. 
Void MainWindow::DrawContent(SFXRectangleConstRef screenRect, SFXGraphicsPtr graphics)
{
    VCalCollectionPtr vcalCollection = SyncScheduler::GetVCalCollection();
    SFXRectangle calRect;

    calRect.Set(screenRect);
    calRect.AddTop(screenRect.GetBottom() - 40);
    SInt32 todayIndex = vcalCollection->GetIndex(
    _cursor.GetYear(), _cursor.GetMonth(), _cursor.GetDay());
    SInt32 todaySize =
    vcalCollection->GetNumberOfVCal(
    todayIndex, _cursor.GetYear(), _cursor.GetMonth(), _cursor.GetDay());
	calRect.AddTop(- 50);

	_totalshow = todaySize-1;
	// draw the scroll arrow
	SFXTriangle arrowup( screenRect.GetRight() /2 ,screenRect.GetBottom() -65,
						 screenRect.GetRight() /2 -8,screenRect.GetBottom() -65 +5,
						 screenRect.GetRight() /2 +8,screenRect.GetBottom() -65 +5 );
	SFXTriangle arrowdown( screenRect.GetRight() /2 ,screenRect.GetBottom() -5,
						 screenRect.GetRight() /2 -8,screenRect.GetBottom() -5 -5,
						 screenRect.GetRight() /2 +8,screenRect.GetBottom() -5 -5 );
	if (_showcursor == 1) {
		graphics->FillTriangle(arrowup,SFXRGBColor (100, 100, 100, 0));
	}
	else {
		graphics->FillTriangle(arrowup,SFXRGBColor (255, 30, 30, 0));
	}
		if (_showcursor == _totalshow) {
		graphics->FillTriangle(arrowdown,SFXRGBColor (100, 100, 100, 0));
	}
	else {
		graphics->FillTriangle(arrowdown,SFXRGBColor (255, 30, 30, 0));
	}
	// draw the current scheduler items
	SFXList<VCalendarFilePtr>::Enumerator e = vcalCollection->GetEnumerator(todayIndex);
	VCalendarPtr vcal;
	for (int i = 0; i<todaySize; i++) {
		vcal = e.GetNext();
		int item = i +1;
		SFXAnsiString bottomString = SFXAnsiString::Format("%d of %d/ ",item,todaySize);
		bottomString += SFXAnsiString::Format("%02d:%02d ", vcal->GetStartDate().GetHour(), vcal->GetStartDate().GetMinute());
		bottomString += vcal->GetSummary();
		if (i >=  (_showcursor-1) && i <=(_showcursor +MAXLINE_TO_SHOW -2) ) {
    	graphics->DrawText(bottomString, calRect,SFXRGBColor (0, 0, 0, 0), IDF_ALIGN_LEFT);
		calRect.AddTop(+ 40);
		}
	}
    return;
}


// Key handleriwhen the window is in the foreground and the key is pushed , it is executed.j
HANDLER_IMPLEMENT_BOOLEVENT(MainWindow, OnKey, event)
{
    Bool result(false);
    switch (event.GetP16()) {
    case AVK_SELECT:            
        // If select key is pressed
        ::new OneDayWindow(_cursor);
        result = true;
        break;
    case AVK_LEFT:
        _cursor.SubDay(1);      // Move day left
        InvalidateContent();    // A new area is registered
		_showcursor=1;
        result = true;
        break;
    case AVK_RIGHT:
        _cursor.AddDay(1);      // Move day right
        InvalidateContent();    // A new area is registered
		_showcursor=1;
        result = true;
        break;
    case AVK_UP:
        _cursor.SubDay(7);      // Move day up
        InvalidateContent();    // A new area is registered
		_showcursor=1;
        result = true;
        break;
    case AVK_DOWN:
        _cursor.AddDay(7);      // Move day down
        InvalidateContent();    // A new area is registered
		_showcursor=1;
        result = true;
        break;
	case AVK_2:
        if (_showcursor>1) {
			_showcursor--;		// Scrool the Schedulers up
		}
		InvalidateContent();
		 result = true;
        break;
	case AVK_8:
        if (_showcursor + MAXLINE_TO_SHOW - 1  <= _totalshow) {
			_showcursor++;		// Scrool the Schedulers dowm
		}
		InvalidateContent(); 
		result = true;
        break;
    }
    return result;
}


HANDLER_IMPLEMENT_VOIDEVENT(MainWindow, OnSoftkey, event)
{
    SFRMultiDialogPtr dialog;
    SFRMultiDialog::ParamRec param;
    SFRTextMenuPtr menu;
    SFCError error(SFERR_NO_ERROR);

    switch (event.GetP16()) {
    case SoftkeyWindow::SOFTKEY_1:
        param.text = "Are You Done?";
        param.ok = "Yes";
        param.cancel = "No";
        param.focus = SFRMultiDialog::FOCUS_CANCEL;
        param.image = SFBShell::GetInstance()->LoadResImage(SYNCSCHEDULER_RES_FILE, ACCEPT);
        if ((dialog = ::new SFRMultiDialog(SyncScheduler::CalculateDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_HEIGHT), "Confirmation", param)) != null) {
            SyncScheduler::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromSoftkey1));
        }
        break;
    case SoftkeyWindow::SOFTKEY_2:
        if ((menu = ::new SFRTextMenu(SyncScheduler::CalculateMenuPosition(OPERATION_LIMIT), "Menu", null, 0)) != null) {
            if ((error = menu->static_catch()) == SFERR_NO_ERROR) {
                if ((error = menu->AppendItem("Environmental Setting", AVK_1, 0xFBF6)) == SFERR_NO_ERROR) {
                    if ((error = menu->AppendItem("Version", AVK_UNDEFINED)) == SFERR_NO_ERROR) {
                        error = SyncScheduler::OpenStandardMenu(menu, HANDLER_FUNCTION(FromSoftkey2));
                    }
                }
            }
            if (error != SFERR_NO_ERROR) {
                ::delete menu;
            }
        }
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, FromSoftkey1, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        SyncScheduler::CloseStandardDialog(dialog);
        SFRApplication::Terminate();
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        SyncScheduler::CloseStandardDialog(dialog);
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDMENU(MainWindow, FromSoftkey2, result, menu)
{
    SFRDialogPtr dialog;
    switch (result) {
    case OPERATION_PREFERENCE:
        SyncScheduler::CloseStandardMenu(menu);
        if ((dialog = ::new PreferenceDialog) != null) {
            SyncScheduler::OpenCustomDialog(dialog, HANDLER_FUNCTION(FromPreference));
        }
        break;
    case OPERATION_VERSION:
        SyncScheduler::CloseStandardMenu(menu);
        if ((dialog = ::new VersionDialog) != null) {
            SyncScheduler::OpenCustomDialog(dialog, HANDLER_FUNCTION(FromVersion));
        }
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        SyncScheduler::CloseStandardMenu(menu);
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, FromPreference, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        SyncScheduler::CloseCustomDialog(dialog);
        // TODO
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        SyncScheduler::CloseCustomDialog(dialog);
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, FromVersion, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        SyncScheduler::CloseCustomDialog(dialog);
        break;
    }
    return;
}

