#ifndef __ONEDAYWINDOW_HPP
#define __ONEDAYWINDOW_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(OneDayWindow)
class OneDayWindow : public SFRPlainWindow {
    SFMSEALCOPY(OneDayWindow)
private:
    SInt16 _displine;               // Head of displayed line
    SInt16 _cursor;                 // Cursor position
    SInt16 _maxline;                // Number of lines displayed 
    SFXDateConst _date;             // Date of the current day
    SInt32 _index;                  // Index of VCalendar at date of _date
    SInt32 _number;                 // The number of VCalendar
    SFRMultiDialogPtr dialog;
 public:
    OneDayWindow(SFXDateConstRef date) static_throws;
    virtual ~OneDayWindow(Void);
    HANDLER_DECLARE_VOIDRENDER(OnRenderContent) // Drawing handler
    HANDLER_DECLARE_BOOLEVENT(OnKey)            // Key handler
	HANDLER_DECLARE_VOIDDIALOG(FromSoftkey1)	// Quit Handler
	HANDLER_DECLARE_VOIDDIALOG(OnDelete)
};

#endif //__ONEDAYWINDOW_HPP
