//
//      PreferenceDialog.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//
#include "PreferenceDialog.hpp"
#include "SyncScheduler.hpp"
#include "SoftkeyWindow.hpp"
#include "syncscheduler_res.h"
#define		MARGIN					(4)
#define     TOP_MARGIN              (1)
#define     PANEDATE_NAME               ("Date display")
#define     LABEL_SOFTKEY1          ("Finish")
#define     LABEL_SOFTKEY2          ("Back")
#define     LABEL_SOFTKEY3          ("Select")

PreferenceDialog::PreferenceDialog(Void) static_throws : SFRPlainDialog(SFXRectangle(0, 0, 0, 0), BEHAVIOR_SFRPLAINDIALOG, ATTRIBUTE_PREFERENCEDIALOG)
{
    SoftkeyWindowPtr softkey;
    SFRTabControlPtr tab;
    SFRTabPanePtr panedate;
    SFXRectangle rect;
    SFXConfigPtr option = SyncScheduler::GetOption();
    SoftkeyWindow::Initialize(this);
    if (static_try()) {
        static_throw(RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
        if (static_try()) {
            SetBaseBound(SyncScheduler::CalculateWindowPosition());
            rect = GetContentWorld();
            rect.AddTop(TOP_MARGIN);
            if ((tab = ::new SFRTabControl(this, rect)) != null) {
                static_throw(*tab);
                if (static_try()) {
                    if ((panedate = ::new SFRTabPane(tab, PANEDATE_NAME)) != null) {
                        static_throw(*panedate);
                        if (static_try()) {
                            Select();
                            if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                                static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_1, LABEL_SOFTKEY1));
                                if (static_try()) {
                                    static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2));
                                    if (static_try()) {
                                        static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
                                        if (static_try()) {
                                            SetReference(softkey->Bind(this));
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else {
                        static_throw(SFERR_NO_MEMORY);
                    }
                }
            }
            else {
                static_throw(SFERR_NO_MEMORY);
            }
        }
    }
    SInt16 fontHeight = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL);
    rect.Deflate(MARGIN, MARGIN);
    rect.SetHeight(fontHeight + MARGIN);
    ::new SFRLabelControl(panedate, rect, "Date Format:");
    rect.AddY(MARGIN + fontHeight);
    //Display the Months in Numbers(Short display)
    _radioNormaldate = ::new SFRRadiobuttonControl(panedate, rect,"Display Month Numerically");
    rect.AddY(MARGIN + fontHeight);
    //Display the Months in English(Long display)
    _radioLongdate = ::new SFRRadiobuttonControl(panedate, rect,"Display Month by Name");
    _radioLongdate->Group(_radioNormaldate);
    if (option->ReadBool(OPTION_LONGDATE, false)) {
        _radioLongdate->SetStatusCheck(true);
    }
    else {
        _radioNormaldate->SetStatusCheck(true);
    }
    rect.AddY(MARGIN + fontHeight + 10);
    ::new SFRLabelControl(panedate, rect, "Date Style:");
    rect.AddY(MARGIN + fontHeight);
    //Display date in Year-Month-Day style (Japan style)
    _radioYMD = ::new SFRRadiobuttonControl(panedate, rect,"JP Style(YY-MM-DD)");
    rect.AddY(MARGIN + fontHeight);
    //Display date in Month-Day-Year style (western style)
    _radioMDY = ::new SFRRadiobuttonControl(panedate, rect,"US Style(MM-DD-YY)");
    _radioMDY->Group(_radioYMD);
    if (option->ReadBool(OPTION_MDY, false)) {
        _radioMDY->SetStatusCheck(true);
    }
    else {
        _radioYMD->SetStatusCheck(true);
    }
    rect.AddY(MARGIN + fontHeight);
    rect.AddY(MARGIN + fontHeight);
    rect.SetWidth( (tab->GetContentWorld().GetWidth())/2 - 2*MARGIN);
    SFRButtonControlPtr buttonOk = ::new SFRButtonControl(panedate,rect, "Apply");
    rect.AddX(rect.GetWidth() + MARGIN);
    SFRButtonControlPtr buttonCancel = ::new SFRButtonControl(panedate,rect, "Cancel");
    if (static_try()) {
        static_throw(
        buttonOk->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlOk)));
    }
    if (static_try()) {
        static_throw(
        buttonCancel->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlCancel)));
    }
    return;
}


PreferenceDialog::~PreferenceDialog(Void)
{
    SoftkeyWindow::Terminate(this);
    return;
}


//option window ok button handler
HANDLER_IMPLEMENT_VOIDCONTROL(PreferenceDialog, OnButtonControlOk, result, control)
{
    //Save the option data
    SFXConfigPtr option = SyncScheduler::GetOption();
    option->WriteBool(OPTION_LONGDATE,_radioLongdate->GetStatusCheck());
    option->WriteBool(OPTION_MDY,_radioMDY->GetStatusCheck());
    option->Save();
    //CLose Window
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}


HANDLER_IMPLEMENT_VOIDCONTROL(PreferenceDialog, OnButtonControlCancel, result, control)
{
    //CLose Window
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}


HANDLER_IMPLEMENT_VOIDEVENT(PreferenceDialog, OnSoftkey, event)
{
    switch (event.GetP16()) {
    case SoftkeyWindow::SOFTKEY_1:
        {
            #define     MULTIDIALOG_HEIGHT      (136)
            enum 
			{
                OPERATION_PREFERENCE,
                OPERATION_VERSION,
                OPERATION_LIMIT
            };
            SFRMultiDialogPtr dialog;
            SFRMultiDialog::ParamRec param;
            SFCError error(SFERR_NO_ERROR);
            param.text = "Are You Done?";
            param.ok = "Yes";
            param.cancel = "No";
            param.focus = SFRMultiDialog::FOCUS_CANCEL;
            param.image = SFBShell::GetInstance()->LoadResImage(SYNCSCHEDULER_RES_FILE, ACCEPT);
            if ((dialog = ::new SFRMultiDialog(SyncScheduler::CalculateDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_HEIGHT), "Confirmation", param)) != null) {
                SyncScheduler::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromSoftkey1));
            }
        }
        break;
    case SoftkeyWindow::SOFTKEY_2:
        Invoke(SFXEvent(SREVT_DIALOG, SRP16_OK, reinterpret_cast<UInt32>(this)));
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(PreferenceDialog, FromSoftkey1, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        SyncScheduler::CloseStandardDialog(dialog);
        SFRApplication::Terminate();
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        SyncScheduler::CloseStandardDialog(dialog);
        break;
    }
    return;
}

