//
//      SoftkeyWindow.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#ifndef __SOFTKEYWINDOW_HPP
#define __SOFTKEYWINDOW_HPP

#include <SophiaFramework.hpp>

SFMRESPONDERATTRIBUTE(SOFTKEYWINDOW, four_char_code('S', 'o', 'f', 't'))

SFMTYPEDEFCLASS(SoftkeyWindow)
class SoftkeyWindow : public SFRPlainWindow {
    SFMSEALCOPY(SoftkeyWindow)
public:
    enum {
        USEREVT_SOFTKEY = SFEVT_USER + 0x0100
    };
    enum SoftkeyEnum {
        SOFTKEY_1,
        SOFTKEY_2,
        SOFTKEY_3,
        SOFTKEY_LIMIT
    };

private:
    SFMTYPEDEFSTRUCT(ItemRec)
    struct ItemRec {
        SFRResponderPtr responder;
        SFXWideString label[SOFTKEY_LIMIT];
        Bool enable[SOFTKEY_LIMIT];
    };

private:
    SFXList<ItemRecPtr> _item;
    SFRResponderPtr _bind;

public:
    explicit SoftkeyWindow(SFRApplicationPtr director) static_throws;
    virtual ~SoftkeyWindow(Void);
    static SoftkeyWindowPtr GetInstance(Void);
    SFRResponderPtr Bind(SFRResponderPtr responder);
    SFCError Register(SFRResponderPtr responder, SoftkeyEnum index, SFXWideStringConstRef label, Bool enable = true);
    Void Unregister(SFRResponderPtr responder);
    static Void Initialize(SFRResponderPtr responder);
    static Void Terminate(SFRResponderPtr responder);
private:
    HANDLER_DECLARE_VOIDRENDER(OnRender)
    HANDLER_DECLARE_BOOLEVENT(OnSoftkey)
    Void DrawButton(SFXGraphicsPtr graphics, SFXRectangleConstRef rect, SFXWideStringConstRef string);
    ItemRecPtr Find(SFRResponderPtr responder) const;
};

#endif // __SOFTKEYWINDOW_HPP //
