//
//      SyncScheduler.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#include "SyncScheduler.hpp"
#include "SoftkeyWindow.hpp"
#include "MainWindow.hpp"

#define     INVALID_MEMORY_SIZE     (192000)
#define     DIALOG_MARGIN           (12)
#define     MENU_MARGIN             (2)
#define     LABEL_SOFTKEY2          ("Close")
#define     LABEL_SOFTKEY3          ("Select")

// Boot loader
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    // The license code is set here when using it on a real mobile device. 

    *license = "heap://"
		
		"Y0TPT8RHWMYDUJZ6TKU1ROX8RBX2SBT3RPV1T0Y7XLW0KVNS8ROYFR4YOX7UET6U1DS4YLY7Y"
		"MVHR9SETPY4TQOMRMCSOROX9XLPU1WLRFNGUBT8XJU4Y7XPUARLXOS6VJS7U0XQRLV009Y7W2"
		"RLS5UKQVHYQTIR6W0SDPXGXMY9SPOT0VBRORNV2XAW1R9S34YNVHT1TAX9Z7UDDSDT3SLZCVE"
		"UD2X2Y9Z1WHVMXNX8GVASOYPRGZBEVERNTPW6WOTQY0VDFYO30Y8SIRAUMW1VEUPSIXBYMZ9U"
		"JWCVCTNZ0U8WBX9UIT7XET0XMYLV9YJ1LY4S7V3X8W6W6WBZ0YEXIXJZBVBYJRNWMVCR4/";

    return (id == AEECLSID_SYNCSCHEDULER) ? (&SyncScheduler::Factory) : (null);
}

// Factory function
SFCInvokerPtr SyncScheduler::Factory(Void)
{
    SFCInvokerPtr result(null);

	#if TARGET_VERSION_GE(4, 0, 0)
    result = ::new SyncScheduler;
    #else
    SFBHeapSmp heap;
    if ((heap = SFBHeap::NewInstance()) != null) {
        if (heap->CheckAvail(INVALID_MEMORY_SIZE)) {
            result = ::new SyncScheduler;
        }
    }
    #endif
	return result;
}

// Constructor
SyncScheduler::SyncScheduler(Void) static_throws
{
    SFRWindowPtr window;

    // Various handlers are registered here. 

    if (static_try()) {

        // All a clear key events are blocked so that the application program cannot end with a clear key. 

        #if TARGET_VERSION_GE(3, 1, 0)
        static_throw(RegisterHandler(SFEVT_KEY, SFEVT_KEY_RELEASE, AVK_CLR, HANDLER_AFTER, HANDLER_NULL));
        #else
        static_throw(RegisterHandler(SFEVT_KEY, SFEVT_KEY_HELD, AVK_CLR, HANDLER_AFTER, HANDLER_NULL));
        #endif
        if (static_try()) {
            static_throw(RegisterHandler(SFEVT_APP_START, HANDLER_BEFORE, HANDLER_FUNCTION(OnAppStart)));
            if (static_try()) {
                static_throw(RegisterHandler(SFEVT_APP_STOP, HANDLER_AFTER, HANDLER_FUNCTION(OnAppStop)));
                if (static_try()) {
                    static_throw(RegisterHandler(SFEVT_APP_RESUME, HANDLER_BEFORE, HANDLER_FUNCTION(OnAppResume)));
                    if (static_try()) {
                        static_throw(RegisterHandler(SFEVT_APP_SUSPEND, HANDLER_AFTER, HANDLER_FUNCTION(OnAppSuspend)));
                        if (static_try()) {
                            if ((window = ::new SoftkeyWindow(this)) != null) {
                                static_throw(*window);
                                if (static_try()) {
									 _option.Load(SFXPath("/calendar/option.dat"));
                                    if ((window = ::new MainWindow(this)) != null) {
                                        static_throw(*window);
                                        if (static_try()) {
                                            // Data is read from the file. 
                                            _vcalCollection.ReadIndexFile();
                                        }
                                    }
                                    else {
                                        static_throw(SFERR_NO_MEMORY);
                                    }
                                }
                            }
                            else {
                                static_throw(SFERR_NO_MEMORY);
                            }
                        }
                    }
                }
            }
        }
    }
    return;
}

// Destructor
SyncScheduler::~SyncScheduler(Void)
{
    return;
}

// Application start up handler
HANDLER_IMPLEMENT_VOIDSTART(SyncScheduler, OnAppStart, environment)
{
    // Hides warnings for unused variable  

    unused(environment);

    // The processing when the application start up is described here

    return;
}

// Application stop handler
HANDLER_IMPLEMENT_VOIDSTOP(SyncScheduler, OnAppStop, quitable)
{
    // Hides warnings for unused variable

    unused(quitable);

    // The processing when the application stops is described here. 

    return;
}

// Application restart handler.
HANDLER_IMPLEMENT_VOIDRESUME(SyncScheduler, OnAppResume, environment)
{
    // Hides warnings for unused variable 

    unused(environment);

    // The processing when the application restarts is described here 

    return;
}

// Application suspends handler
HANDLER_IMPLEMENT_VOIDSUSPEND(SyncScheduler, OnAppSuspend, reason, info)
{
    // Hides warnings for unused variable

    unused(reason);
    unused(info);

    // The processing when the application suspends is described here

    return;
}

SFXRectangle SyncScheduler::CalculateWindowPosition(Void)
{
    SoftkeyWindowPtr softkey;
    SFXRectangle result(GetInstance()->GetContentWorld());

    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
        result.SubBottom(softkey->GetBaseBound().GetHeight());
    }
    return result;
}

SFXRectangle SyncScheduler::CalculateDialogPosition(SFXMarginConstRef margin, SInt16 height)
{
    SoftkeyWindowPtr softkey;
    SFXRectangle rect(GetInstance()->GetContentWorld());
    SFXRectangle result(0, 0, 0, 0);

    result.SetSize(rect.GetWidth() - DIALOG_MARGIN * 2 - margin.GetLeft() - margin.GetRight(), height);
    result.Offset(SFXGrid(rect.GetSize() - result.GetSize()) / 2);
    result.Inflate(margin);
    result.AddY(margin.GetTop() - margin.GetBottom());
    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
        result.SubY(softkey->GetBaseBound().GetHeight());
    }
    return result;
}

SFXRectangle SyncScheduler::CalculateMenuPosition(SInt16 limit)
{
    SoftkeyWindowPtr softkey;
    SFXRectangle rect(GetInstance()->GetContentWorld());
    SInt16 height;
    SFXRectangle result(0, 0, 0, 0);

    height = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + MENU_MARGIN;
    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
        rect.SubBottom(softkey->GetBaseBound().GetHeight());
    }
    result.SetSize(rect.GetWidth() * 3 / 4, height * limit);
    result.Inflate(SFRTextMenu::GetMargin());
    result.SetOrigin(0, 0);
    result.Offset(SFXGrid(rect.GetSize() - result.GetSize()));
    return result;
}

SFCError SyncScheduler::OpenStandardDialog(SFRDialogPtr dialog, SFRHandlerSPP procedure, VoidPtr reference)
{
    SoftkeyWindowPtr softkey;
    SFCError error(SFERR_NO_ERROR);

    if ((error = dialog->static_catch()) == SFERR_NO_ERROR) {
        if ((error = dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, procedure, reference)) == SFERR_NO_ERROR) {
            SoftkeyWindow::Initialize(dialog);
            if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                if ((error = softkey->Register(dialog, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3)) == SFERR_NO_ERROR) {
                    dialog->SetReference(softkey->Bind(dialog));
                }
            }
        }
    }
    if (error != SFERR_NO_ERROR) {
        ::delete dialog;
    }
    return error;
}

Void SyncScheduler::CloseStandardDialog(SFRDialogPtr dialog)
{
    SoftkeyWindow::Terminate(dialog);
    dialog->DialogHandler();
    return;
}

SFCError SyncScheduler::OpenCustomDialog(SFRDialogPtr dialog, SFRHandlerSPP procedure, VoidPtr reference)
{
    SFCError error(SFERR_NO_ERROR);

    if ((error = dialog->static_catch()) == SFERR_NO_ERROR) {
        error = dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, procedure, reference);
    }
    if (error != SFERR_NO_ERROR) {
        ::delete dialog;
    }
    return error;
}

Void SyncScheduler::CloseCustomDialog(SFRDialogPtr dialog)
{
    dialog->DialogHandler();
    return;
}

SFCError SyncScheduler::OpenStandardMenu(SFRMenuPtr menu, SFRHandlerSPP procedure, VoidPtr reference)
{
    SoftkeyWindowPtr softkey;
    SFCError error(SFERR_NO_ERROR);

    if ((error = menu->static_catch()) == SFERR_NO_ERROR) {
        if ((error = menu->RegisterHandler(SREVT_MENU, HANDLER_BEFORE, procedure, reference)) == SFERR_NO_ERROR) {
            if ((error = menu->RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, OnSoftkeySHP, menu)) == SFERR_NO_ERROR) {
                SoftkeyWindow::Initialize(menu);
                if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                    if ((error = softkey->Register(menu, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2)) == SFERR_NO_ERROR) {
                        if ((error = softkey->Register(menu, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3)) == SFERR_NO_ERROR) {
                            menu->SetReference(softkey->Bind(menu));
                        }
                    }
                }
            }
        }
    }
    return error;
}

Void SyncScheduler::CloseStandardMenu(SFRMenuPtr menu)
{
    SoftkeyWindow::Terminate(menu);
    menu->MenuHandler();
    return;
}

Bool SyncScheduler::OnSoftkeySHP(SFXEventConstRef event, VoidPtr reference)
{
    SFRMenuPtr menu;

    switch (event.GetP16()) {
        case SoftkeyWindow::SOFTKEY_2:
            menu = static_cast<SFRMenuPtr>(reference);
            menu->Invoke(SFXEvent(SREVT_MENU, SRP16_CANCEL, reinterpret_cast<UInt32>(menu)));
            break;
    }
    return true;
}

// Get instance of VCalCollection
VCalCollectionPtr SyncScheduler::GetVCalCollection(Void)
{
    return &static_cast<SyncSchedulerPtr>(GetInstance())->_vcalCollection;
}

// Get options
SFXConfigPtr SyncScheduler::GetOption(Void)
{
    return &(static_cast<SyncSchedulerPtr>(GetInstance())->_option);
}